#Options

#NoTrayIcon
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <GUIEdit.au3>
#include <ScrollBarConstants.au3>
#include <Zip.au3>
#include <RevisedSave.au3>
#include <Inet.au3>
#include <TextileSpelling.au3>
#include <ButtonConstants.au3>
AutoItSetOption("WinTitleMatchMode",3)

#Global Variables

Global $sv = ""
Global $p = 0
Global $f = 0
Global $ww = 0
Global $u = 0
Global $ut = ""
Global $font = "Arial"
Global $pfs = 80
Global $nfs = 8.5
Global $sel = ""
Global $finddid = 0
Global $findmatch = 0
Global $findup = 0
Global $findtext = ""
Global $fsmode = 0

#ASCII Art

$buildingd="                 ,.::::.                " &@CRLF& "                .i:::::i:               " &@CRLF& "               .i:.....:::              "
$buildingd=$buildingd&@CRLF&"               ;pHHHssstFt              " &@CRLF& "   :viiiiiii;  :tUsUsUJUU7  .riiiiiivi  "
$buildingd=$buildingd&@CRLF&"   .QQbQSQbQcGbbSHriHvi;d1ZEkQMQ6GMQQ:  " &@CRLF& "   .bZHdUEHGrb112JvUSFc;SUPSU9kb2pF6E:  "
$buildingd=$buildingd&@CRLF&" 7Gvvvr;r;rvr;vi:::FPpL:i:v;;;;;;;;;vvG:" &@CRLF& " sQibQ9QFQ9QrQEEZk:QQQp.QtQG1QZQ6QZQGiQ:"
$buildingd=$buildingd&@CRLF&" :9:iriiiiir:ii...,rr;.,..:i:riiiiiii:6 "

$libertyd="   iEr,            "&@CRLF&"  bML              "&@CRLF&"JbGQ,              "&@CRLF&".tQU               "&@CRLF&"  QQ     ,         "
$libertyd=$libertyd&@CRLF&"  GQs  : :, ,      "&@CRLF&"  ivr..:ccHi       "&@CRLF&"    k.:.E1H6Qv     "&@CRLF&"    .2.Uv,1QQ1     "
$libertyd=$libertyd&@CRLF&"     ,QkU.1QQG     "&@CRLF&"      Qi pQcprr.   "&@CRLF&"      vv , .1itL;, "
$libertyd=$libertyd&@CRLF&"       S.  Qk.PQPQ "&@CRLF&"      pp,tL;QpcbQQi"&@CRLF&"      6; vQsQQ1bQQQ"
$libertyd=$libertyd&@CRLF&"     ,Q: ,:QQQQQQQQ"&@CRLF&"     :Q,.v:QQbQQQQ;"&@CRLF&"     ,Q i ,MGpQQQE "
$libertyd=$libertyd&@CRLF&"      Q;. :Q6pQQ   "&@CRLF&"      PQ: .QrrQQ   "&@CRLF&"      ;Qi iQciQQ,  "
$libertyd=$libertyd&@CRLF&"      .;7pQQG:QQ   "&@CRLF&"      ,cQQQtSQQQ   "&@CRLF&"      ..1MQ.iQQQ   "
$libertyd=$libertyd&@CRLF&"      .QU9QrUQQ2   "&@CRLF&"      :Qv1QtcQQQ   "&@CRLF&"      vsvGQJ,QQQ9  "
$libertyd=$libertyd&@CRLF&"      Q2QQbd:QQQG  "&@CRLF&"     :H1. 2GUFQQQ  "&@CRLF&"     ,,i:iQGGE6EQQJ"

$stard="        Ep       "&@CRLF&"       QUkG      "&@CRLF&"   ,.:Gd,,Qk.    "&@CRLF&",GQ12FU.:iipGGQQS"&@CRLF&"  9M:,:rv7cLcMQP "
$stard=$stard&@CRLF&"   .Q2rLJtH2QZ   "&@CRLF&"    PG72dZ6bQv   "&@CRLF&"    QGQQGGQQQQ   "&@CRLF&"    Qi      ;Q   "

$flagd="QcGQJQbFQsQQJQdpQGQQQQQQQQQQQQQQQQQQQQQQ"&@CRLF&"QLUtUHUU2UstUHsE:                       "&@CRLF&"Qt21P2Fk1P12P1FGH:rr;;;;;;;;;;;;;;;;;;;i"
$flagd=$flagd&@CRLF&"Qt2FP1FkFSF1SFkQi                       "&@CRLF&"QUFSFSFFpFkSFPkGPrLccccccccccccccccccccL"&@CRLF&"QP6dMd6ddE66EddQ;                       "
$flagd=$flagd&@CRLF&"Q7PdcZ1sGUpdcZFSSvcJJJJJJJJJJJJJJJJJJJJc"&@CRLF&"                                        "
$flagd=$flagd&@CRLF&"Uivvvvvvvvvvvvvvv777777777777777777777Lv"&@CRLF&"                                        "
$flagd=$flagd&@CRLF&"c:iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiirri"

$globed="                       ,:::i:.                      "&@CRLF&"                   .:............,                  "&@CRLF&"              9QQci::vU1kri;JcLpc::;Lc:             "&@CRLF&"           JQQQG..:U6QQQQQQQQQQQQGcr;irvL.          "&@CRLF&"         pQQQQv,,cQQQE699b6b6666ZQG7:.;r:;L:        "&@CRLF&"       7QQQQGQ6vpQG9SF122kPppPb6bbbsv.vQ2.r;7.      "&@CRLF&"      QQQQGZGEEt7791sHUUsJrv::rc29pMQdiiQU.iicQ     "&@CRLF&"     QQQGZEEk.,...UStLUcU;:r.....i1HsbMk9Z::::QQ    "&@CRLF&"    QQQGEdbpF2v::::;U;rUcv7UJv::.:Hi:FkSi;2:,tQQL   "&@CRLF&"   QQQGE6bPk1bS::i:.:r:i;v;ivJc:.vHcJUU2kPZt:cQ1rc  "&@CRLF&"  QQQGEd9PFHs1L.iiii::::irv;:;vv:ic77LcUHS9Q2 1;:;r "&@CRLF&"  QQGMdbpS2sUH::iiiii:ii::i;riir;r;;vvLJUHFbpir:irc "&@CRLF&" GQQGE69S1tUs2i:iii::::ii.:i:::iiiir;vvLJUtFdQM::rv "&@CRLF&" QQGMdbpkHsUtr::ii::::::ii::::::vvrir;vLcUt1PdQJ:r;:"&@CRLF&"2QQGMd9PFHUHv.:iii:i:::::::::i;rir;irrvvLJUHk9Gc.r;i"&@CRLF&"QQQGMd9PFHU2i.iiii:i:::::::::iii:::ir;v7cJUHk9QU.ir:"&@CRLF&"SQQGMEbPFHs2i.:iii:i:::::::ii...:::ir;v7LJs2k9ZG:.:."&@CRLF&",QQGZEbPFHs2L:::ii:::::::::;...:::ii;vvLcUH2S9EQE:;2"&@CRLF&" QQQGM69k1tstc;.::i:::::::i:.::::iir;vvccsHFP9EGQQQ:"&@CRLF&" .QQGMEbpF2sst1:::::;riiir:::::iiir;vvLcUt1Sp6MGQQQ "&@CRLF&"  QQQGEd9PFHUUFv..:Lcvvrrvriiiiir;vv7cJUt2FpbdMGQQ; "&@CRLF&"   QQQGEd9PF2sstci.rvrrvv77;v;;vvvvLcJUt1SpbdMGQQQ  "&@CRLF&"   .QQQGMdbpS2Ht12c;r::v7vv7cLJUJUsstHFkPb6EZGQQQ   "&@CRLF&"    .QQQGZE69Pk1HsH2HtU..UJsUUHtsUHPbdMGGQQQQQQQ    "&@CRLF&"      QQQQGMdb9Pk11tsHFtvJFJ::i::::r;rvdGdk7QQU     "&@CRLF&"       FQQQQGZE6bpPSk11kPp9i::::iii:::::::.EQ       "&@CRLF&"         GQQQQGGMEd6b9ppdH,.:iiirirrrrrr;;J;        "&@CRLF&"           2QQQQQQGGZMEdG6v:.:irr;;;vvcJr           "&@CRLF&"              SQQQQQQQGGGQQQt:i;vvLcJr,             "&@CRLF&"                  .vF6MGGGQQQG..,                   "


#GUI Controls

$top = RegRead("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Top")
$left = RegRead("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Left")
$width = RegRead("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Width")
$height = RegRead("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Height")
If $top = "" Then $top = -1
If $left = "" Then $left = -1
If $width = "" Then $width = 640
If $height = "" Then $height = 480
If $top > 4294967290 Then $top = 0
If $left > 4294967290 Then $left = 0
$top = Number($top)
$left = Number($left)
$width = Number($width)
$height = Number($height)

$win = GUICreate("Textile",640,480,-1,-1,$WS_MAXIMIZEBOX+$WS_MINIMIZEBOX+$WS_SIZEBOX)
$file = GUICtrlCreateMenu("File")
Global $new = GUICtrlCreateMenuItem("New	Ctrl+N",$file)
$open = GUICtrlCreateMenuItem("Open	Ctrl+O",$file)
$save = GUICtrlCreateMenuItem("Save	Ctrl+S",$file)
$saveas = GUICtrlCreateMenuItem("Save As",$file)
GUICtrlCreateMenuItem("",$file)
$savecopy = GUICtrlCreateMenuItem("Save Copy",$file)
$revert = GUICtrlCreateMenuItem("Revert",$file)
$rename = GUICtrlCreateMenuItem("Rename",$file)
$email = GUICtrlCreateMenuItem("Email",$file)
GUICtrlCreateMenuItem("",$file)
$importrtf = GUICtrlCreateMenuItem("Import",$file)
$export = GUICtrlCreateMenuItem("Export",$file)
GUICtrlCreateMenuItem("",$file)
$print = GUICtrlCreateMenuItem("Print	Ctrl+P",$file)
GUICtrlCreateMenuItem("",$file)
$exit = GUICtrlCreateMenuItem("Exit",$file)
$edit = GUICtrlCreateMenu("Edit")
$undo = GUICtrlCreateMenuItem("Undo	Ctrl+Z",$edit)
$redo = GUICtrlCreateMenuItem("Redo	Ctrl+Y",$edit)
GUICtrlCreateMenuItem("",$edit)
$cut = GUICtrlCreateMenuItem("Cut	Ctrl+X",$edit)
$copy = GUICtrlCreateMenuItem("Copy	Ctrl+C",$edit)
$paste = GUICtrlCreateMenuItem("Paste	Ctrl+V",$edit)
$delete = GUICtrlCreateMenuItem("Delete	Del",$edit)
GUICtrlCreateMenuItem("",$edit)
$find = GUICtrlCreateMenuItem("Find	Ctrl+F",$edit)
$findnext = GUICtrlCreateMenuItem("Find Next	F3",$edit)
$replace = GUICtrlCreateMenuItem("Replace	Ctrl+R",$edit)
GUICtrlCreateMenuItem("",$edit)
$goto = GUICtrlCreateMenuItem("Go To	Ctrl+G",$edit)
$selectall = GUICtrlCreateMenuItem("Select All	Ctrl+A",$edit)
$view = GUICtrlCreateMenu("View")
$fixedwidth = GUICtrlCreateMenuItem("Fixed Width",$view)
$wordwrap = GUICtrlCreateMenuItem("Word Wrap",$view)
GUICtrlCreateMenuItem("",$view,2)
$zoomin = GUICtrlCreateMenuItem("Zoom In",$view)
$zoomout = GUICtrlCreateMenuItem("Zoom Out",$view)
$zoomreset = GUICtrlCreateMenuItem("Zoom Reset",$view)
$insert = GUICtrlCreateMenu("Insert")
$datetime = GUICtrlCreateMenuItem("Date/Time	F5",$insert)
$horizrule = GUICtrlCreateMenuItem("Horizontal Rule",$insert)
$symbol = GUICtrlCreateMenuItem("Symbol",$insert)
$grid = GUICtrlCreateMenuItem("Grid",$insert)
$bullets = GUICtrlCreateMenuItem("Bullets",$insert)
$numbers = GUICtrlCreateMenuItem("Numbers",$insert)
$autowordsmenu = GUICtrlCreateMenu("Auto Words",$insert)
$autowords = GUICtrlCreateMenuItem("View List",$autowordsmenu)
$saluclos = GUICtrlCreateMenu("Salutations and Closing Lines",$autowordsmenu)
$dearmadam = GUICtrlCreateMenuItem("Dear Madam:",$saluclos)
$dearsir = GUICtrlCreateMenuItem("Dear Sir:",$saluclos)
$dearsirormadam = GUICtrlCreateMenuItem("Dear Sir or Madam:",$saluclos)
$sincerely = GUICtrlCreateMenuItem("Sincerely,",$saluclos)
$towhomitmayconcern = GUICtrlCreateMenuItem("To whom it may concern:",$saluclos)
$yourstruly = GUICtrlCreateMenuItem("Yours truly,",$saluclos)
$headings = GUICtrlCreateMenu("Headings",$autowordsmenu)
$attn = GUICtrlCreateMenuItem("Attn:",$headings)
$createdby = GUICtrlCreateMenuItem("Created By:",$headings)
$createdon = GUICtrlCreateMenuItem("Created On:",$headings)
$re = GUICtrlCreateMenuItem("Re:",$headings)
$subject = GUICtrlCreateMenuItem("Subject:",$headings)
$to = GUICtrlCreateMenuItem("To:",$headings)
$messagephrases = GUICtrlCreateMenu("Message Phrases",$autowordsmenu)
$couldyoupleasesendme = GUICtrlCreateMenuItem("Could you please send me",$messagephrases)
$iamwritinginregardto = GUICtrlCreateMenuItem("I am writing in regard to",$messagephrases)
$ifyouhavefurtherquestions = GUICtrlCreateMenuItem("If you have further questions",$messagephrases)
$ilookforwardtohearingfromyou = GUICtrlCreateMenuItem("I look forward to hearing from you.",$messagephrases)
$thankyouforyour = GUICtrlCreateMenuItem("Thank you for your",$messagephrases)
$wewouldbehappyto = GUICtrlCreateMenuItem("We would be happy to",$messagephrases)
$asciimenu = GUICtrlCreateMenu("ASCII Art",$insert)
$asciiart = GUICtrlCreateMenuItem("Use File",$asciimenu)
$asciigallery = GUICtrlCreateMenu("Gallery",$asciimenu)
$building = GUICtrlCreateMenuItem("Building",$asciigallery)
$liberty = GUICtrlCreateMenuItem("Statue Of Liberty",$asciigallery)
$star = GUICtrlCreateMenuItem("Star",$asciigallery)
$flag = GUICtrlCreateMenuItem("American Flag",$asciigallery)
$globe = GUICtrlCreateMenuItem("Globe",$asciigallery)
$format = GUICtrlCreateMenu("Format")
$uppercase = GUICtrlCreateMenuItem("Make Upper Case",$format)
$lowercase = GUICtrlCreateMenuItem("Make Lower Case",$format)
$propercase = GUICtrlCreateMenuItem("Make Proper Case",$format)
$sentencecase = GUICtrlCreateMenuItem("Make Sentence Case",$format)
$tools = GUICtrlCreateMenu("Tools")
$lookupmenu = GUICtrlCreateMenu("Look Up Word",$tools)
$lookup = GUICtrlCreateMenuItem("Merriam-Webster",$lookupmenu)
$lookup2 = GUICtrlCreateMenuItem("Wiktionary",$lookupmenu)
$wordcount = GUICtrlCreateMenuItem("Word Count",$tools)
$summarize = GUICtrlCreateMenuItem("Summarize",$tools)
$plugin = GUICtrlCreateMenuItem("Run Plugin",$tools)
$fixspell = GUICtrlCreateMenuItem("Fix Mistakes",$tools)
$help = GUICtrlCreateMenu("Help")
$help = GUICtrlCreateMenuItem("Help Contents",$help)
$about = GUICtrlCreateMenuItem("About Textile",$help)
$edit = GUICtrlCreateEdit("",0,0,640,435,BitOr($GUI_SS_DEFAULT_EDIT,$ES_NOHIDESEL))

If $top < 0 Or $left < 0 Or $width < 2 Or $height < 2 Or $top > @DesktopHeight Or $left > @DesktopWidth Then
Else
If $top = 0 And $left = 0 And $width > (@DesktopWidth-50) And $height > (@DesktopHeight-50) Then
WinSetState($win,"",@SW_MAXIMIZE)
Else
WinMove($win,"",$left,$top,$width,$height)
EndIf
EndIf

#GUI Preparation

GUICtrlSetFont($edit,8.5,400,0,"Arial")
GUICtrlSetState($cut,$GUI_ENABLE)
GUICtrlSetState($copy,$GUI_ENABLE)
GUICtrlSetState($delete,$GUI_ENABLE)
GUICtrlSetState($fixedwidth,$GUI_UNCHECKED)
GUICtrlSetState($wordwrap,$GUI_UNCHECKED)
GUISetState()

While 1

#Get Selection, Set Hotkeys and Disable Menu Items

$sel = _GUICtrlEdit_GetSel($edit)
If WinActive($win) = 0 Then
HotKeySet("^n")
HotKeySet("^o")
HotKeySet("^s")
HotKeySet("^p")
HotKeySet("^z")
HotKeySet("^f")
HotKeySet("^r")
HotKeySet("^a")
HotKeySet("^y")
HotKeySet("^g")
HotKeySet("{F1}")
HotKeySet("{F3}")
HotKeySet("{F5}")
EndIf
If WinActive($win) = 1 Then
HotKeySet("^n","New")
HotKeySet("^o","Open")
HotKeySet("^s","Save")
If $p = 0 Then HotKeySet("^p","Print")
HotKeySet("^z","Undo")
HotKeySet("^f","Find")
HotKeySet("^r","Replace")
HotKeySet("^a","SelectAll")
HotKeySet("^y","Redo")
HotKeySet("^g","Goto")
HotKeySet("{F1}","Help")
HotKeySet("{F3}","FindNext")
HotKeySet("{F5}","DateTime")
EndIf
$s = _GUICtrlEdit_GetSel($edit)
If $s[0] = $s[1] Then
If GUICtrlGetState($cut) = $GUI_ENABLE Then
GUICtrlSetState($cut,$GUI_DISABLE)
GUICtrlSetState($copy,$GUI_DISABLE)
GUICtrlSetState($delete,$GUI_DISABLE)
EndIf
EndIf
If $s[0] <> $s[1] Then
If GUICtrlGetState($cut) = $GUI_DISABLE Then
GUICtrlSetState($cut,$GUI_ENABLE)
GUICtrlSetState($copy,$GUI_ENABLE)
GUICtrlSetState($delete,$GUI_ENABLE)
EndIf
EndIf

#Get GUI Messages and allow closing functions

$msg = GUIGetMsg()
If $msg = $GUI_EVENT_CLOSE Then
If $f = 0 Then DoExit()
EndIf
If $msg = $exit Then DoExit()

#Menu Item Function References

If $msg = $new Then New()
If $msg = $open Then Open()
If $msg = $save Then Save()
If $msg = $saveas Then SaveAs()
If $msg = $savecopy Then SaveCopy()
If $msg = $revert Then Revert()
If $msg = $rename Then Rename()
If $msg = $email Then _INetMail("","Document sent from Textile",GUICtrlRead($edit))
If $msg = $importrtf Then Import()
If $msg = $export Then Export()
If $msg = $print Then Print()
If $msg = $undo Then Undo()
If $msg = $redo Then Redo()
If $msg = $delete Then SelectAll()
If $msg = $cut Then Cut()
If $msg = $copy Then ClipPut(GetSel())
If $msg = $paste Then AddNoLine(ClipGet())
If $msg = $find Then Find()
If $msg = $findnext Then FindNext()
If $msg = $replace Then Replace()
If $msg = $goto Then Goto()
If $msg = $selectall Then SelectAll()
If $msg = $wordcount Then WordCount()
If $msg = $summarize Then Summarize()
If $msg = $lookup Then LookUp("http://www.merriam-webster.com/dictionary/")
If $msg = $lookup2 Then LookUp("http://en.wiktionary.org/wiki/")
If $msg = $plugin Then PlugIn()
If $msg = $fixspell Then FixMistakes()
If $msg = $fixedwidth Then FixedWidth()
If $msg = $wordwrap Then WordWrap()
If $msg = $zoomin Then ZoomIn()
If $msg = $zoomout Then ZoomOut()
If $msg = $zoomreset Then ZoomReset()
If $msg = $uppercase Then _GUICtrlEdit_ReplaceSel($edit,StringUpper(GetSel()))
If $msg = $lowercase Then _GUICtrlEdit_ReplaceSel($edit,StringLower(GetSel()))
If $msg = $propercase Then ProperCase()
If $msg = $sentencecase Then _GUICtrlEdit_ReplaceSel($edit,StringUpper(StringLeft(GetSel(),1))&StringLower(StringTrimLeft(GetSel(),1)))
If $msg = $datetime Then DateTime()
If $msg = $horizrule Then Horiz()
If $msg = $grid Then Grid()
If $msg = $bullets Then Bullets()
If $msg = $numbers Then Numbers()
If $msg = $asciiart Then ASCIIArt()
If $msg = $autowords Then AutoWords()
If $msg = $dearmadam Then AddNoLine("Dear Madam:")
If $msg = $dearsir Then AddNoLine("Dear Sir:")
If $msg = $dearsirormadam Then AddNoLine("Dear Sir or Madam:")
If $msg = $sincerely Then AddNoLine("Sincerely,")
If $msg = $towhomitmayconcern Then AddNoLine("To whom it may concern:")
If $msg = $yourstruly Then AddNoLine("Yours truly,")
If $msg = $attn Then AddNoLine("Attn:")
If $msg = $createdby Then AddNoLine("Created By:")
If $msg = $createdon Then AddNoLine("Created On:")
If $msg = $re Then AddNoLine("Re:")
If $msg = $subject Then AddNoLine("Subject:")
If $msg = $to Then AddNoLine("To:")
If $msg = $couldyoupleasesendme Then AddNoLine("Could you please send me")
If $msg = $iamwritinginregardto Then AddNoLine("I am writing in regard to")
If $msg = $ifyouhavefurtherquestions Then AddNoLine("If you have any further questions")
If $msg = $ilookforwardtohearingfromyou Then AddNoLine("I look forward to hearing from you.")
If $msg = $thankyouforyour Then AddNoLine("Thank you for your")
If $msg = $wewouldbehappyto Then AddNoLine("We would be happy to")
If $msg = $building Then InsertClipart($buildingd)
If $msg = $liberty Then InsertClipart($libertyd)
If $msg = $star Then InsertClipart($stard)
If $msg = $flag Then InsertClipart($flagd)
If $msg = $globe Then InsertClipart($globed)
If $msg = $help Then Help()
If $msg = $about Then MsgBox(64,"About","Textile - a free plaintext word processor."&@CRLF&"Created by Jason. Version 1.04."&@CRLF&"Some code from AutoIt forum members torels and MsCreatoR.")

If $msg = $symbol Then Symbol()

Wend

DoExit()

Func DoExit()
If AreYouSure() = 6 Then
$wgp = WinGetPos($win)
RegWrite("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Left","REG_DWORD",$wgp[0])
RegWrite("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Top","REG_DWORD",$wgp[1])
RegWrite("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Width","REG_DWORD",$wgp[2])
RegWrite("HKEY_LOCAL_MACHINE\Software\Textile\WindowPos","Height","REG_DWORD",$wgp[3])
Exit
EndIf
EndFunc

#Menu Item Functions

Func FindNext()
$cb = $findmatch
If $findup = 0 Then
$sel = _GUICtrlEdit_GetSel($edit)
$rfac = 1
If StringInStr(GUICtrlRead($edit),$findtext,$cb,1,$sel[1]) = 0 Then $rfac = 0
_GUICtrlEdit_SetSel($edit,StringInStr(GUICtrlRead($edit),$findtext,$cb,1,$sel[1])-$rfac,StringInStr(GUICtrlRead($edit),$findtext,$cb,1,$sel[1])+StringLen($findtext)-$rfac)
Else
$rfac = 1
If StringInStr(GUICtrlRead($edit),$findtext,$cb,-1,$sel[0]) = 0 Then $rfac = 0
_GUICtrlEdit_SetSel($edit,StringInStr(GUICtrlRead($edit),$findtext,$cb,-1,$sel[0])-$rfac,StringInStr(GUICtrlRead($edit),$findtext,$cb,-1,$sel[0])+StringLen($findtext)-$rfac)
$sel2 = _GUICtrlEdit_GetSel($edit)
If $sel2[0] = $sel[0] And $sel2[1] = $sel[1] Then
_GUICtrlEdit_SetSel($edit,StringInStr(GUICtrlRead($edit),$findtext,$findmatch,-1,StringLen(GUICtrlRead($edit)))-$rfac-1,StringInStr(GUICtrlRead($edit),$findtext,$findmatch,-1,StringLen(GUICtrlRead($edit)))+StringLen($findtext)-$rfac-1)
EndIf
EndIf
EndFunc

Func FixMistakes()
$sure = MsgBox(64,"Fix Mistakes","Fix Mistakes will fix some common spelling mistakes"&@CRLF&"However it is not as good as a spell checker, so we recommend you proofread as well.")
$newstr = ""
$ssge = StringSplit(GUICtrlRead($edit)," "&@CR)
For $i = 1 To $ssge[0]
$nssge = $ssge[$i]
$lf = 0
If StringLeft($nssge,1) = @LF Then
$lf = 1
$nssge = StringTrimLeft($nssge,1)
EndIf
$end = ""
$start = ""
$done = 0
While $done = 0
$ri = StringRight($nssge,1)
If $ri = "." Or $ri = "," Or $ri = "!" Or $ri = ")" Or $ri = "'" Or $ri = """" Then
$end = StringRight($nssge,1) & $end
$nssge = StringTrimRight($nssge,1)
Else
$done = 1
EndIf
Wend
$done = 0
While $done = 0
$ri = StringLeft($nssge,1)
If $ri = "(" Or $ri = "'" Or $ri = """" Then
$start = StringLeft($nssge,1) & $start
$nssge = StringTrimLeft($nssge,1)
Else
$done = 1
EndIf
Wend
$case = 0
If StringLeft($nssge,1) == StringUpper(StringLeft($nssge,1)) Then $case = 1
If $nssge == StringUpper($nssge) Then $case = 2
$nssge = FixSpell(StringLower($nssge))
If $case = 1 Then $nssge = StringUpper(StringLeft($nssge,1)) & StringTrimLeft($nssge,1)
If $case = 2 Then $nssge = StringUpper($nssge)
$ssge[$i] = $start & $nssge & $end
If $lf = 0 Then $newstr = $newstr & $ssge[$i] & " "
If $lf = 1 Then $newstr = StringTrimRight($newstr,1) & @CRLF & $ssge[$i] & " "
Next
$newstr = StringTrimRight($newstr,1)
GUICtrlSetData($edit,$newstr)
EndFunc

Func ProperCase()
$in = GetSel()
$in = StringSplit($in," ")
$str = ""
For $i = 1 To $in[0]
$str = $str & StringUpper(StringLeft($in[$i],1)) & StringLower(StringTrimLeft($in[$i],1)) & " "
Next
$str = StringTrimRight($str,1)
$str = StringSplit($str,@CRLF,1)
$newstr = ""
For $i = 1 To $str[0]
$newstr = $newstr & StringUpper(StringLeft($str[$i],1)) & StringTrimLeft($str[$i],1) & @CRLF
Next
$newstr = StringTrimRight($newstr,2)
_GUICtrlEdit_ReplaceSel($edit,$newstr)
EndFunc

Func PlugIn()
$fo = FileOpenDialog("Open",@ScriptDir,"Plugin files (*.exe)",1)
If @error <> 1 Then
$sure = MsgBox(48+4,"Plugin Warning","WARNING: Plugins are dangerous and can be viruses."&@CRLF&"Only run this plugin if it is from a trusted source."&@CRLF&"Are you sure you want to run this plugin?")
If $sure = 6 Then
FileWrite(@TempDir&"\plugin.txt",GUICtrlRead($edit))
ShellExecuteWait($fo)
GUICtrlSetData($edit,FileRead(@TempDir&"\plugin.txt"))
FileDelete(@TempDir&"\plugin.txt")
EndIf
EndIf
EndFunc

Func Revert()
If $sv <> "" Then
If AreYouSure() = 6 Then
GUICtrlSetData($edit,EnterFix(FileRead($sv)))
EndIf
Else
MsgBox(16,"Error","Nothing to revert to.")
EndIf
EndFunc

Func Symbol()
$f = 1
$aww = GUICreate("Symbol",200,400,-1,-1,-1,-1,$win)
Global $ils = GUICtrlCreateList("",0,0,200,380)
GUICtrlSetData($ils,"||||||||||")
GUICtrlSetFont($ils,20,400,0,"Arial")
$ins = GUICtrlCreateButton("Insert",0,370,200,30,$BS_DEFPUSHBUTTON)
Global $exitafter = 0
GUISetState()
$f = 0
While 1
$bmsg = GUIGetMsg(1)
$msg = $bmsg[0]
If $msg = $GUI_EVENT_CLOSE Then
If $bmsg[1] = $aww Then
ExitLoop
Else
DoExit()
EndIf
EndIf
If $msg = $ins Then
$r = GUICtrlRead($edit)
$f = StringLeft($r,$s[0])
$b = StringTrimLeft($r,$s[1])
GUICtrlSetData($edit,$f&GUICtrlRead($ils)&$b)
$exitafter = 1
EndIf
If $exitafter = 1 Then ExitLoop
Wend
GUIDelete()
$f = 0
EndFunc

Func AutoWords()
$f = 1
$aww = GUICreate("Auto Words",300,400,-1,-1,-1,-1,$win)
Global $ils = GUICtrlCreateList("",0,0,300,380)
GUICtrlSetData($ils,"Dear Madam:|Dear Sir:|Dear Sir or Madam:|Sincerely,|To whom it may concern:|Yours truly,|Attn:|Created By:|Created On:|Re:|Subject:|To:|Could you please send me|I am writing in regard to|If you have further questions|I look forward to hearing from you.|Thank you for your|We would be happy to")
$ins = GUICtrlCreateButton("Insert",0,370,300,30,$BS_DEFPUSHBUTTON)
Global $exitafter = 0
GUISetState()
$f = 0
While 1
$bmsg = GUIGetMsg(1)
$msg = $bmsg[0]
If $msg = $GUI_EVENT_CLOSE Then
If $bmsg[1] = $aww Then
ExitLoop
Else
DoExit()
EndIf
EndIf
If $msg = $ins Then
$r = GUICtrlRead($edit)
$f = StringLeft($r,$s[0])
$b = StringTrimLeft($r,$s[1])
GUICtrlSetData($edit,$f&GUICtrlRead($ils)&$b)
$exitafter = 1
EndIf
If $exitafter = 1 Then ExitLoop
Wend
GUIDelete()
$f = 0
EndFunc

Func Summarize()
$sure = MsgBox(48+4,"Summarization Warning","WARNING: Summarizing is not perfect and could even delete your entire document."&@CRLF&"It cannot be undone, and is completely UNSAFE."&@CRLF&"Are you sure you want to do this?")
If $sure = 6 Then
$s = ""
$pos = 1
$r = GUICtrlRead($edit)
While 1
$p1 = StringInStr($r,".",0,1,$pos)
$p2 = StringInStr($r,"!",0,1,$pos)
$p3 = StringInStr($r,"?",0,1,$pos)
$p = $p1
If $p2 < $p And $p2 <> 0 Then $p = $p2
If $p3 < $p And $p3 <> 0 Then $p = $p3
If $p = 0 Then ExitLoop
$sn = StringMid($r,$pos,$p-$pos+1)
$u = 0
If StringInStr($sn,"also") <> 0 Then $u = 1
If StringInStr($sn,"again") <> 0 Then $u = 1
If StringInStr($sn,"as well as") <> 0 Then $u = 1
If StringInStr($sn,"besides") <> 0 Then $u = 1
If StringInStr($sn,"coupled with") <> 0 Then $u = 1
If StringInStr($sn,"furthermore") <> 0 Then $u = 1
If StringInStr($sn,"in addition") <> 0 Then $u = 1
If StringInStr($sn,"likewise") <> 0 Then $u = 1
If StringInStr($sn,"moreover") <> 0 Then $u = 1
If StringInStr($sn,"similarly") <> 0 Then $u = 1
If StringInStr($sn,"accordingly") <> 0 Then $u = 1
If StringInStr($sn,"as a result") <> 0 Then $u = 1
If StringInStr($sn,"consequently") <> 0 Then $u = 1
If StringInStr($sn,"for this reason") <> 0 Then $u = 1
If StringInStr($sn,"for this purpose") <> 0 Then $u = 1
If StringInStr($sn,"hence") <> 0 Then $u = 1
If StringInStr($sn,"otherwise") <> 0 Then $u = 1
If StringInStr($sn,"so then") <> 0 Then $u = 1
If StringInStr($sn,"subsequently") <> 0 Then $u = 1
If StringInStr($sn,"therefore") <> 0 Then $u = 1
If StringInStr($sn,"thus") <> 0 Then $u = 1
If StringInStr($sn,"thereupon") <> 0 Then $u = 1
If StringInStr($sn,"wherefore") <> 0 Then $u = 1
If StringInStr($sn,"as a rule") <> 0 Then $u = 1
If StringInStr($sn,"as usual") <> 0 Then $u = 1
If StringInStr($sn,"for the most part") <> 0 Then $u = 1
If StringInStr($sn,"generally") <> 0 Then $u = 1
If StringInStr($sn,"generally speaking") <> 0 Then $u = 1
If StringInStr($sn,"ordinarily") <> 0 Then $u = 1
If StringInStr($sn,"usually") <> 0 Then $u = 1
If StringInStr($sn,"chiefly") <> 0 Then $u = 1
If StringInStr($sn,"especially") <> 0 Then $u = 1
If StringInStr($sn,"for instance") <> 0 Then $u = 1
If StringInStr($sn,"in particular") <> 0 Then $u = 1
If StringInStr($sn,"markedly") <> 0 Then $u = 1
If StringInStr($sn,"namely") <> 0 Then $u = 1
If StringInStr($sn,"particularly") <> 0 Then $u = 1
If StringInStr($sn,"including") <> 0 Then $u = 1
If StringInStr($sn,"specifically") <> 0 Then $u = 1
If StringInStr($sn,"such as") <> 0 Then $u = 1
If StringInStr($sn,"for example") <> 0 Then $u = 1
If StringInStr($sn,"for instance") <> 0 Then $u = 1
If StringInStr($sn,"for one thing") <> 0 Then $u = 1
If StringInStr($sn,"as an illustration") <> 0 Then $u = 1
If StringInStr($sn,"illustrated with") <> 0 Then $u = 1
If StringInStr($sn,"as an example") <> 0 Then $u = 1
If StringInStr($sn,"in this case") <> 0 Then $u = 1
If StringInStr($sn,"above all") <> 0 Then $u = 1
If StringInStr($sn,"chiefly") <> 0 Then $u = 1
If StringInStr($sn,"with attention to") <> 0 Then $u = 1
If StringInStr($sn,"especially") <> 0 Then $u = 1
If StringInStr($sn,"particularly") <> 0 Then $u = 1
If StringInStr($sn,"singularly") <> 0 Then $u = 1
If StringInStr($sn,"comparitively") <> 0 Then $u = 1
If StringInStr($sn,"correspondingly") <> 0 Then $u = 1
If StringInStr($sn,"identically") <> 0 Then $u = 1
If StringInStr($sn,"similar") <> 0 Then $u = 1
If StringInStr($sn,"together with") <> 0 Then $u = 1
If StringInStr($sn,"aside from") <> 0 Then $u = 1
If StringInStr($sn,"barring") <> 0 Then $u = 1
If StringInStr($sn,"besides") <> 0 Then $u = 1
If StringInStr($sn,"except") <> 0 Then $u = 1
If StringInStr($sn,"exclu") <> 0 Then $u = 1
If StringInStr($sn,"other than") <> 0 Then $u = 1
If StringInStr($sn,"outside of") <> 0 Then $u = 1
If StringInStr($sn,"save") <> 0 Then $u = 1
If StringInStr($sn,"in essence") <> 0 Then $u = 1
If StringInStr($sn,"in other words") <> 0 Then $u = 1
If StringInStr($sn,"namely") <> 0 Then $u = 1
If StringInStr($sn,"that is") <> 0 Then $u = 1
If StringInStr($sn,"that is to say") <> 0 Then $u = 1
If StringInStr($sn,"in short") <> 0 Then $u = 1
If StringInStr($sn,"in brief") <> 0 Then $u = 1
If StringInStr($sn,"to put it differently") <> 0 Then $u = 1
If StringInStr($sn,"contrast") <> 0 Then $u = 1
If StringInStr($sn,"by the same token") <> 0 Then $u = 1
If StringInStr($sn,"conversely") <> 0 Then $u = 1
If StringInStr($sn,"instead") <> 0 Then $u = 1
If StringInStr($sn,"on one hand") <> 0 Then $u = 1
If StringInStr($sn,"on the other hand") <> 0 Then $u = 1
If StringInStr($sn,"on the contrary") <> 0 Then $u = 1
If StringInStr($sn,"rather") <> 0 Then $u = 1
If StringInStr($sn,"yet") <> 0 Then $u = 1
If StringInStr($sn,"but") <> 0 Then $u = 1
If StringInStr($sn,"however") <> 0 Then $u = 1
If StringInStr($sn,"still") <> 0 Then $u = 1
If StringInStr($sn,"nevertheless") <> 0 Then $u = 1
If StringInStr($sn,"at first") <> 0 Then $u = 1
If StringInStr($sn,"first of all") <> 0 Then $u = 1
If StringInStr($sn,"to begin with") <> 0 Then $u = 1
If StringInStr($sn,"in the first place") <> 0 Then $u = 1
If StringInStr($sn,"at the same time") <> 0 Then $u = 1
If StringInStr($sn,"for now") <> 0 Then $u = 1
If StringInStr($sn,"for the time being") <> 0 Then $u = 1
If StringInStr($sn,"next") <> 0 Then $u = 1
If StringInStr($sn,"in time") <> 0 Then $u = 1
If StringInStr($sn,"in turn") <> 0 Then $u = 1
If StringInStr($sn,"later") <> 0 Then $u = 1
If StringInStr($sn,"meanwhile") <> 0 Then $u = 1
If StringInStr($sn,"then") <> 0 Then $u = 1
If StringInStr($sn,"soon") <> 0 Then $u = 1
If StringInStr($sn,"meantime") <> 0 Then $u = 1
If StringInStr($sn,"while") <> 0 Then $u = 1
If StringInStr($sn,"earlier") <> 0 Then $u = 1
If StringInStr($sn,"simultaneously") <> 0 Then $u = 1
If StringInStr($sn,"after") <> 0 Then $u = 1
If StringInStr($sn,"in conclusion") <> 0 Then $u = 1
If StringInStr($sn,"with this in mind") <> 0 Then $u = 1
If StringInStr($sn,"after all") <> 0 Then $u = 1
If StringInStr($sn,"all in all") <> 0 Then $u = 1
If StringInStr($sn,"all things considered") <> 0 Then $u = 1
If StringInStr($sn,"briefly") <> 0 Then $u = 1
If StringInStr($sn,"by and large") <> 0 Then $u = 1
If StringInStr($sn,"in any case") <> 0 Then $u = 1
If StringInStr($sn,"in any event") <> 0 Then $u = 1
If StringInStr($sn,"in brief") <> 0 Then $u = 1
If StringInStr($sn,"in conclusion") <> 0 Then $u = 1
If StringInStr($sn,"on the whole") <> 0 Then $u = 1
If StringInStr($sn,"in short") <> 0 Then $u = 1
If StringInStr($sn,"in summary") <> 0 Then $u = 1
If StringInStr($sn,"in the final analysis") <> 0 Then $u = 1
If StringInStr($sn,"in the long run") <> 0 Then $u = 1
If StringInStr($sn,"on balance") <> 0 Then $u = 1
If StringInStr($sn,"to sum up") <> 0 Then $u = 1
If StringInStr($sn,"to summarize") <> 0 Then $u = 1
If StringInStr($sn,"finally") <> 0 Then $u = 1
If StringInStr($sn,"by the way") <> 0 Then $u = 1
If StringInStr($sn,"incedentally") <> 0 Then $u = 1
If StringInStr($sn,"here") <> 0 Then $u = 1
If StringInStr($sn,"beyond") <> 0 Then $u = 1
If StringInStr($sn,"nearly") <> 0 Then $u = 1
If StringInStr($sn,"opposite") <> 0 Then $u = 1
If StringInStr($sn,"under") <> 0 Then $u = 1
If StringInStr($sn,"above") <> 0 Then $u = 1
If StringInStr($sn,"to the left") <> 0 Then $u = 1
If StringInStr($sn,"to the right") <> 0 Then $u = 1
If StringInStr($sn,"in the distance") <> 0 Then $u = 1
If $u = 1 Then $s = $s & $sn
$pos = $p + 1
Wend
GUICtrlSetData($edit,$s)
EndIf
EndFunc

Func InsertClipart($v)
Add($v)
FixedWidthOn()
EndFunc

Func WordCount()
$r = StringSplit(GUICtrlRead($edit)," "&@CRLF)
$s = 0
For $i = 1 to $r[0]
If $r[$i] <> "" Then $s = $s + 1
Next
$wc = $s
$r = StringSplit(GUICtrlRead($edit),@CRLF)
$s = 0
For $i = 1 to $r[0]
If $r[$i] <> "" Then $s = $s + 1
Next
$lc = $s
$r = StringReplace(GUICtrlRead($edit),@CRLF,"")
$cc = StringLen($r)
MsgBox(0,"Word Count","Words: "&$wc&@CRLF&"Lines: "&$lc&@CRLF&"Letters: "&$cc)
EndFunc

Func Horiz()
$c = ""
For $i = 1 to 80
$c = $c & "-"
Next
Add($c)
EndFunc

Func Export()
$fxxxx = _FileSaveDialog("Export",@ScriptDir,"Word Files (*.doc)|*.doc|RTF Files (*.rtf)|*.rtf|HTML Files (*.htm)|*.htm")
$r = GUICtrlRead($edit)
If StringRight($fxxxx,3) = "rtf" Then
$r = StringReplace($r,@CRLF,"\line"&@CRLF)
$r = "{\rtf1\ansi\deff0{\fonttbl{\f0 " & $font & ";}}\f0\fs" & ($nfs*2) & " " & $r & "}"
EndIf
If StringRight($fxxxx,3) = "htm" Then
$r = StringReplace($r,"&","&amp;")
$r = StringReplace($r,"<","&lt;")
$r = StringReplace($r,">","&gt;")
$r = StringReplace($r,"""","&quot;")
$r = "<html><body><pre style=""font-family:" & $font & ";font-size:" & $nfs & "pt;"">" & $r & "</pre></body></html>"
EndIf
If StringRight($fxxxx,3) = "doc" Then
$r = StringReplace($r,@CRLF,"\line"&@CRLF)
$r = "{\rtf1\ansi\deff0{\fonttbl{\f0 " & $font & ";}}\f0\fs" & ($nfs*2) & " " & $r & "}"
EndIf
If FileExists($fxxxx) Then FileDelete($fxxxx)
FileWrite($fxxxx,$r)
EndFunc

Func Help()

$htext = "What is Textile?"&@CRLF&@CRLF&"Textile is a word processor, much like Microsoft Word. However it has two advantages."&@CRLF&"1. It is simple and easy to use, unlike Word with its confusing user interface. It also takes up very little hard drive space."&@CRLF&"2. Instead of using Word's proprietary format it uses plaintext. Plaintext is a way of storing text without all the formatting (different fonts, colors, styles, etc.) Plaintext files are very small and can be opened on almost any computer."&@CRLF&@CRLF&"How do you use Textile?"&@CRLF&@CRLF&"When you open Textile you will see menus at the top to perform various functions. Below that is a box to enter text in, much like Microsoft Word."&@CRLF&@CRLF&"What formats can Textile open?"&@CRLF&@CRLF&"It can open Unix, Mac and Windows plain text files. It also has a crude system for importing RTF, Word, Word 2007, HTML, and OpenDocument files."&@CRLF&@CRLF&"Is Textile under a license such as the GPL?"&@CRLF&@CRLF&"No! Textile is free and in the public domain. You can do whatever you want with it or the source it is distributed with."&@CRLF&@CRLF

$htext2 = "A quick guide to the functions available in the menus."&@CRLF&@CRLF&"File Menu"&@CRLF&@CRLF&"New: Makes a new document."&@CRLF&"Open: Opens a plain text file."&@CRLF&"Save: Saves the current document."&@CRLF&"Save As: Saves the current document with a different name."&@CRLF&"Save Copy: Saves a seperate copy of a file."&@CRLF&"Revert: Reverts to the saved version of the document."&@CRLF&"Import: Opens a RTF, DOC, DOCX, HTML or ODT file."&@CRLF&"Export: Saves the current file as an RTF, HTML or DOC file."&@CRLF&"Print: Prints the current file."&@CRLF&"Exit: Leaves Textile."&@CRLF&@CRLF&"Edit Menu"&@CRLF&@CRLF&"Undo: Undoes the most recent action."&@CRLF&"Redo: Redoes the most recent undone action."&@CRLF&"Delete: Deletes currently selected text."&@CRLF&"Cut: Deletes currently selected text and puts it on the clipboard."&@CRLF&"Copy: Puts currently selected text on the clipboard."&@CRLF&"Paste: Adds text to the clipboard to the text."&@CRLF&"Find: Finds text within a document."&@CRLF&"Replace: Replaces text within a document."&@CRLF&"Go To: Goes to a specific line in a document."&@CRLF&"Select All: Selects the entire document."&@CRLF&"Merriam Webster/Wiktionary: Looks up a work in one of two online dictionaries."&@CRLF&"Word Count: Counts the number of words, lines, and letters in a document."&@CRLF&"Summarize: Summarizes the current document."&@CRLF&"Run Plugin: Runs a Textile plugin."&@CRLF&@CRLF&"View Menu"&@CRLF&@CRLF&"Fixed Width: Changes to a fixed width font."&@CRLF&"Word Wrap: Makes text wrap."&@CRLF&"Zoom In/Out: Zooms the text in or out."&@CRLF&"Zoom Reset: Undoes all current zooming."&@CRLF&@CRLF&"Format Menu"&@CRLF&@CRLF&"Make Uppercase/Lowercase: Changes case of selected text."&@CRLF&@CRLF&"Insert Menu"&@CRLF&@CRLF&"Date/Time (Standard/Full): Inserts date and time in 2 different formats."&@CRLF&"Horizontal Rule: Inserts a line going across the page."&@CRLF&"Grid: Inserts a grid"&@CRLF&"Bullets: Inserts a bulleted list."&@CRLF&"Numbers: Inserts a numbered list."&@CRLF&"ASCII  Art: Inserts a file to be used as ASCII art."&@CRLF&"Auto Words: Inserts common text quickly."&@CRLF&"Building, Statue Of Liberty, Star, American Flag, Globe: Inserts ASCII Art from an included gallery."&@CRLF&@CRLF&"Help Menu"&@CRLF&@CRLF&"Help Contents: Opens help."&@CRLF&"About Textile: Shows version number."

$f = 1
$helpwin = GUICreate("Help",500,300)
GUICtrlCreateTab(0,0,500,300)
GUICtrlCreateTabItem("Overview")
$helptext = GUICtrlCreateEdit($htext,10,30,480,260,$WS_VSCROLL+$ES_READONLY)
GUICtrlSetBkColor($helptext,0xFCFCFE)
GUICtrlCreateTabItem("Menu Reference")
$helptext = GUICtrlCreateEdit($htext2,10,30,480,260,$WS_VSCROLL+$ES_READONLY)
GUICtrlSetBkColor($helptext,0xFCFCFE)
GUISetState()
While 1
$msg = GUIGetMsg()
If WinActive("Textile") = 1 Then ExitLoop
If $msg = $GUI_EVENT_CLOSE Then ExitLoop
Wend
GUIDelete()
$f = 0
EndFunc

Func LookUp($prefix)
InetGetSize("http://www.google.com/index.html")
If  @error <> 1 Then
$s = GetSel()
If StringInStr($s," ") = 0 Then
$s = StringReplace($s,".","")
$s = StringReplace($s,"!","")
$s = StringReplace($s,"?","")
$s = StringReplace($s,":","")
$s = StringReplace($s,",","")
$s = StringReplace($s,"-","")
$s = StringReplace($s,"""","")
$s = StringReplace($s,"'","")
$s = StringReplace($s,";","")
ShellExecute($prefix&$s)
Else
MsgBox(16,"Error","Multiple words selected.")
EndIf
Else
MsgBox(16,"Error","No Internet connection.")
EndIf
EndFunc

Func SelectAll()
_GUICtrlEdit_SetSel($edit,0,-1)
EndFunc

Func Cut()
ClipPut(GetSel())
_GUICtrlEdit_ReplaceSel($edit,"")
EndFunc

Func Goto()
$f = 1
Global $gw = GUICreate("Go To",300,30,-1,-1,-1,-1,$win)
Global $gt = GUICtrlCreateInput("",5,5,250,20)
Global $gb = GUICtrlCreateButton("Go To",260,5,35,20,$BS_DEFPUSHBUTTON)
Global $exitafter = 0
GUISetState()
While 1
$bmsg = GUIGetMsg(1)
$msg = $bmsg[0]
If $msg = $GUI_EVENT_CLOSE Then
If $bmsg[1] = $gw Then
ExitLoop
Else
DoExit()
EndIf
EndIf
If $msg = $gb Then
If Number(GUICtrlRead($gt)) >= 1 And Number(GUICtrlRead($gt)) <= _GUICtrlEdit_GetLineCount($edit) Then
If Number(GUICtrlRead($gt)) = 1 Then
$nsel = 0
Else
$nsel = StringInStr(GUICtrlRead($edit),@CRLF,0,Number(GUICtrlRead($gt))-1) + 1
EndIf
_GUICtrlEdit_SetSel($edit,$nsel,$nsel)
_GUICtrlEdit_Scroll($edit,$SB_SCROLLCARET)
$exitafter = 1
Else
MsgBox(48,"Go To","Line does not exist.")
EndIf
EndIf
If $exitafter = 1 Then ExitLoop
Wend
GUIDelete()
$f = 0
EndFunc

Func FixedWidthOn()
GUICtrlSetState($fixedwidth,$GUI_CHECKED)
$font = "Courier New"
GUICtrlSetFont($edit,$nfs,400,0,"Courier New")
EndFunc

Func FixedWidth()
If $font = "Arial" Then
GUICtrlSetState($fixedwidth,$GUI_CHECKED)
$font = "Courier New"
GUICtrlSetFont($edit,$nfs,400,0,"Courier New")
Else
GUICtrlSetState($fixedwidth,$GUI_UNCHECKED)
$font = "Arial"
GUICtrlSetFont($edit,$nfs,400,0,"Arial")
EndIf
EndFunc

Func DateTime()
$ampm = "AM"
$hour = @HOUR
If $hour > 12 Then
$hour = $hour - 12
$ampm = "PM"
EndIf
$minute = (@MIN+1)
If $minute < 10 Then $minute = "0"&$minute
$hour = Number($hour)
$month = @MON
$day = @MDAY
$syear = StringRight(@YEAR,2)
$lyear = @YEAR
$second = @SEC
$weekday = @WDAY
If $weekday = 1 Then $weekday = "Sunday"
If $weekday = 2 Then $weekday = "Monday"
If $weekday = 3 Then $weekday = "Tuesay"
If $weekday = 4 Then $weekday = "Wednesday"
If $weekday = 5 Then $weekday = "Thursday"
If $weekday = 6 Then $weekday = "Friday"
If $weekday = 7 Then $weekday = "Saturday"
If Number($month) = 1 Then $monthname = "January"
If Number($month) = 2 Then $monthname = "February"
If Number($month) = 3 Then $monthname = "March"
If Number($month) = 4 Then $monthname = "April"
If Number($month) = 5 Then $monthname = "May"
If Number($month) = 6 Then $monthname = "June"
If Number($month) = 7 Then $monthname = "July"
If Number($month) = 8 Then $monthname = "August"
If Number($month) = 9 Then $monthname = "September"
If Number($month) = 10 Then $monthname = "October"
If Number($month) = 11 Then $monthname = "November"
If Number($month) = 12 Then $monthname = "December"
$f = 1
$dtw = GUICreate("Date and Time",300,400,-1,-1,-1,-1,$win)
Global $ils = GUICtrlCreateList("",0,0,300,380)
GUICtrlSetData($ils,$month&"/"&$day&"/"&$syear&"|"&$hour&":"&$minute&" "&$ampm&"|"&$month&"/"&$day&"/"&$syear&" "&$hour&":"&$minute&" "&$ampm&"|"&$weekday&", "&$monthname&" "&$day&", "&$lyear&"|"&$lyear&"-"&$month&"-"&$day)
$ins = GUICtrlCreateButton("Insert",0,370,300,30,$BS_DEFPUSHBUTTON)
Global $exitafter = 0
GUISetState()
$f = 0
While 1
$bmsg = GUIGetMsg(1)
$msg = $bmsg[0]
If $msg = $GUI_EVENT_CLOSE Then
If $bmsg[1] = $dtw Then
ExitLoop
Else
DoExit()
EndIf
EndIf
If $msg = $ins Then
$r = GUICtrlRead($edit)
$f = StringLeft($r,$s[0])
$b = StringTrimLeft($r,$s[1])
GUICtrlSetData($edit,$f&GUICtrlRead($ils)&$b)
$exitafter = 1
EndIf
If $exitafter = 1 Then ExitLoop
Wend
GUIDelete()
$f = 0
EndFunc

Func WordWrap()
If $ww = 0 Then
GUICtrlSetState($wordwrap,$GUI_CHECKED)
$ww = 1
$read = GUICtrlRead($edit)
GUICtrlDelete($edit)
$edit = GUICtrlCreateEdit("",0,0,640,435,$ES_NOHIDESEL+$WS_VSCROLL+$ES_WANTRETURN+$ES_AUTOVSCROLL)
GUICtrlSetData($edit,$read)
_GUICtrlEdit_SetSel($edit,$sel[0],$sel[1])
GUICtrlSetFont($edit,$nfs,400,0,$font)
Else
GUICtrlSetState($wordwrap,$GUI_UNCHECKED)
$ww = 0
$read = GUICtrlRead($edit)
GUICtrlDelete($edit)
$edit = GUICtrlCreateEdit("",0,0,640,435,BitOr($GUI_SS_DEFAULT_EDIT,$ES_NOHIDESEL))
GUICtrlSetData($edit,$read)
_GUICtrlEdit_SetSel($edit,$sel[0],$sel[1])
GUICtrlSetFont($edit,$nfs,400,0,$font)
EndIf
EndFunc

Func Redo()
If $ut = GUICtrlRead($edit) Then
_GUICtrlEdit_Undo($edit)
$ut = ""
$u = 0
EndIf
EndFunc

Func Grid()
$f = 1
$rw = GUICreate("Grid",350,90)
GUICtrlCreateLabel("Rows:",5,8,50)
GUICtrlCreateLabel("Columns:",5,33,50)
GUICtrlCreateLabel("Col. Width:",5,63,60)
$rt1 = GUICtrlCreateInput("",55,5,235,20)
$rt2 = GUICtrlCreateInput("",55,30,235,20)
$rt3 = GUICtrlCreateInput("",65,60,225,20)
$rb = GUICtrlCreateButton("Create",295,5,50,75)
GUISetState()
While 1
$msg = GUIGetMsg()
If WinActive("Textile") = 1 Then ExitLoop
If $msg = $GUI_EVENT_CLOSE Then ExitLoop
If $msg = $rb Then
$rows = GUICtrlRead($rt1)
$columns = GUICtrlRead($rt2)
$colwidth = GUICtrlRead($rt3)
$colstring = ""
For $i = 1 To $colwidth
$colstring = $colstring & " "
Next
$colsstring = ""
For $j = 1 To $columns
$colsstring = $colsstring & $colstring & "|"
Next
$colsstring = "|" & $colsstring
$gridv = ""
For $k = 1 To $rows
If $k = $rows Then
$gridv = $gridv & $colsstring
Else
$gridv = $gridv & $colsstring & @CRLF
EndIf
Next
Add($gridv)
ExitLoop
EndIf
Wend
GUIDelete()
$f = 0
EndFunc

Func Bullets()
$f = 1
$fw = GUICreate("Bullets",300,30)
GUICtrlCreateLabel("How Many?",5,8,60)
$ft = GUICtrlCreateInput("",65,5,180,20)
$fb = GUICtrlCreateButton("Create",255,5,40,20)
GUISetState()
While 1
$msg = GUIGetMsg()
If WinActive("Textile") = 1 Then ExitLoop
If $msg = $GUI_EVENT_CLOSE Then ExitLoop
If $msg = $fb Then
$numbullets = GUICtrlRead($ft)
$bstring = ""
For $i = 1 to $numbullets
If $i = $numbullets Then
$bstring = $bstring & " "
Else
$bstring = $bstring & " " & @CRLF
EndIf
Next
Add($bstring)
ExitLoop
EndIf
Wend
GUIDelete()
$f = 0
EndFunc

Func Numbers()
$f = 1
$fw = GUICreate("Bullets",300,30)
GUICtrlCreateLabel("How Many?",5,8,60)
$ft = GUICtrlCreateInput("",65,5,180,20)
$fb = GUICtrlCreateButton("Create",255,5,40,20)
GUISetState()
While 1
$msg = GUIGetMsg()
If WinActive("Textile") = 1 Then ExitLoop
If $msg = $GUI_EVENT_CLOSE Then ExitLoop
If $msg = $fb Then
$numbullets = GUICtrlRead($ft)
$bstring = ""
For $i = 1 to $numbullets
If $i = $numbullets Then
$bstring = $bstring & $i & ". "
Else
$bstring = $bstring & $i & ". " & @CRLF
EndIf
Next
Add($bstring)
ExitLoop
EndIf
Wend
GUIDelete()
$f = 0
EndFunc

Func ASCIIArt()
$fo = FileOpenDialog("Insert ASCII Art",@ScriptDir,"Text Files (*.txt)|All Files (*.*)",1)
$data = EnterFix(FileRead($fo))
Add($data)
FixedWidthOn()
EndFunc

Func ZoomIn()
$nfs = $nfs + 1
GUICtrlSetFont($edit,$nfs,400,0,$font)
$pfs = Floor($nfs)*10
EndFunc

Func ZoomOut()
$nfs = $nfs - 1
GUICtrlSetFont($edit,$nfs,400,0,$font)
$pfs = Floor($nfs)*10
EndFunc

Func ZoomReset()
$nfs = 8.5
GUICtrlSetFont($edit,$nfs,400,0,$font)
$pfs = Floor($nfs)*10
EndFunc

Func New()
If AreYouSure() = 6 Then
GUICtrlSetData($edit,"")
$sv = ""
EndIf
EndFunc

Func Open()
If AreYouSure() = 6 Then
$fo = FileOpenDialog("Open",@ScriptDir,"Text Files (*.txt)|All Files (*.*)",1)
If @error <> 1 Then
$sv = $fo
GUICtrlSetData($edit,EnterFix(FileRead($fo)))
EndIf
EndIf
EndFunc

Func Save()
If $sv = "" Then
SaveAs()
Else
If FileExists($sv) Then FileDelete($sv)
FileWrite($sv,GUICtrlRead($edit))
EndIf
EndFunc

Func Print()
$oldfooter = RegRead("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\PageSetup","footer")
$oldheader = RegRead("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\PageSetup","header")
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\PageSetup","footer","REG_SZ","")
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\PageSetup","header","REG_SZ","")
$r = GUICtrlRead($edit)
$r = StringReplace($r,"&","&amp;")
$r = StringReplace($r,"<","&lt;")
$r = StringReplace($r,">","&gt;")
$r = StringReplace($r,"""","&quot;")
$r = "<html><body><pre style=""font-family:" & $font & ";font-size:" & $nfs & "pt;"">" & $r & "</pre></body></html>"
FileWrite(@TempDir&"\temp.htm",$r)
RunWait(@ComSpec & " /c rundll32.exe " & @SystemDir & "\mshtml.dll,PrintHTML """ & @TempDir & "\temp.htm""",@TempDir,@SW_HIDE)
FileDelete(@TempDir&"\temp.htm")
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\PageSetup","footer","REG_SZ",$oldfooter)
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\PageSetup","header","REG_SZ",$oldheader)
EndFunc

Func Undo()
_GUICtrlEdit_Undo($edit)
$ut = GUICtrlRead($edit)
$u = 1
EndFunc

Func Find()
Global $finddid = 0
Global $findmatch = 0
Global $findup = 0
Global $findtext = ""
$f = 1
Global $fw = GUICreate("Find",300,60,-1,-1,-1,-1,$win)
GUICtrlCreateLabel("Find:",5,8)
Global $ft = GUICtrlCreateInput("",45,5,210,20)
Global $up = GUICtrlCreateRadio("Up",5,35)
Global $down = GUICtrlCreateRadio("Down",45,35)
Global $fcb = GUICtrlCreateCheckbox("Match Case",100,35)
GUICtrlSetState($down, $GUI_CHECKED)
Global $fb = GUICtrlCreateButton("Find",260,5,35,20,$BS_DEFPUSHBUTTON)
GUISetState()
While 1
$bmsg = GUIGetMsg(1)
$msg = $bmsg[0]
If $msg = $GUI_EVENT_CLOSE Then
If $bmsg[1] = $fw Then
ExitLoop
Else
DoExit()
EndIf
EndIf
If $msg = $fb Then


$cb = 0
If GUICtrlRead($fcb) = $GUI_CHECKED Then $cb = 1
If StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb) Then
$finddid = 1
If GUICtrlRead($fcb) = $GUI_CHECKED Then $findmatch = 1
If BitAND(GUICtrlRead($up), $GUI_CHECKED) = $GUI_CHECKED Then $findup = 1
$findtext = GUICtrlRead($ft)
If BitAND(GUICtrlRead($down), $GUI_CHECKED) = $GUI_CHECKED Then
GUISwitch($win)
$sel = _GUICtrlEdit_GetSel($edit)
GUISwitch($fw)
$rfac = 1
If StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,1,$sel[1]) = 0 Then $rfac = 0
_GUICtrlEdit_SetSel($edit,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,1,$sel[1])-$rfac,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,1,$sel[1])+StringLen(GUICtrlRead($ft))-$rfac)
GUISwitch($win)
$sel2 = _GUICtrlEdit_GetSel($edit)
GUISwitch($fw)
If $sel2[0] = $sel[0] And $sel2[1] = $sel[1] Then
_GUICtrlEdit_SetSel($edit,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,2,$sel[1])-$rfac,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,2,$sel[1])+StringLen(GUICtrlRead($ft))-$rfac)
EndIf
GUISwitch($win)
$sel3 = _GUICtrlEdit_GetSel($edit)
$gs = GetSel()
GUISwitch($fw)
If $gs <> GUICtrlRead($ft) Then _GUICtrlEdit_SetSel($edit,$sel3[0]+1,$sel3[1]+1)
Else
GUISwitch($win)
$sel = _GUICtrlEdit_GetSel($edit)
GUISwitch($fw)
$rfac = 1
If StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,-1,$sel[0]) = 0 Then $rfac = 0
_GUICtrlEdit_SetSel($edit,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,-1,$sel[0])-$rfac,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,-1,$sel[0])+StringLen(GUICtrlRead($ft))-$rfac)
GUISwitch($win)
$sel2 = _GUICtrlEdit_GetSel($edit)
GUISwitch($fw)
If $sel2[0] = $sel[0] And $sel2[1] = $sel[1] Then
_GUICtrlEdit_SetSel($edit,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,-1,StringLen(GUICtrlRead($edit)))-$rfac-1,StringInStr(GUICtrlRead($edit),GUICtrlRead($ft),$cb,-1,StringLen(GUICtrlRead($edit)))+StringLen(GUICtrlRead($ft))-$rfac-1)
EndIf
EndIf
Else
MsgBox(16,"Error","Text not found.")
EndIf


EndIf
Wend
GUIDelete()
$f = 0
EndFunc

Func Replace()
$f = 1
Global $rw = GUICreate("Replace",350,80,-1,-1,-1,-1,$win)
GUICtrlCreateLabel("Find:",5,8,50)
GUICtrlCreateLabel("Replace:",5,33,50)
Global $rt1 = GUICtrlCreateInput("",55,5,235,20)
Global $rt2 = GUICtrlCreateInput("",55,30,235,20)
Global $rb = GUICtrlCreateButton("Replace",295,5,50,45,$BS_DEFPUSHBUTTON)
Global $rcb = GUICtrlCreateCheckbox("Match Case",5,55)
Global $exitafter = 0
GUISetState()
While 1
$bmsg = GUIGetMsg(1)
$msg = $bmsg[0]
If $msg = $GUI_EVENT_CLOSE Then
If $bmsg[1] = $rw Then
ExitLoop
Else
DoExit()
EndIf
EndIf
If $msg = $rb Then
$cb = 0
If GUICtrlRead($rcb) = $GUI_CHECKED Then $cb = 1
If StringInStr(GUICtrlRead($edit),GUICtrlRead($rt1)) = 0 Then
MsgBox(16,"Error","Text not found.")
Else
GUICtrlSetData($edit,StringReplace(GUICtrlRead($edit),GUICtrlRead($rt1),GUICtrlRead($rt2),0,$cb))
$exitafter = 1
EndIf
EndIf
If $exitafter = 1 Then ExitLoop
Wend
GUIDelete()
$f = 0
EndFunc

Func Rename()
$fs = _FileSaveDialog("Rename",@ScriptDir,"Text Files (*.txt)|*.txt|All Files (*.*)|*.*",16)
If $fs <> ".txt" Then
FileDelete($sv)
If FileExists($fs) Then FileDelete($fs)
FileWrite($fs,GUICtrlRead($edit))
$sv = $fs
EndIf
EndFunc

Func SaveAs()
$fs = _FileSaveDialog("Save",@ScriptDir,"Text Files (*.txt)|*.txt|All Files (*.*)|*.*",16)
If $fs <> ".txt" Then
$sv = $fs
If FileExists($sv) Then FileDelete($sv)
FileWrite($sv,GUICtrlRead($edit))
EndIf
EndFunc

Func SaveCopy()
$fs = _FileSaveDialog("Save Copy",@ScriptDir,"Text Files (*.txt)|*.txt|All Files (*.*)|*.*",16)
If $fs <> ".txt" Then
If FileExists($fs) Then FileDelete($fs)
FileWrite($fs,GUICtrlRead($edit))
EndIf
EndFunc

Func Import()
If @OSVersion = "WIN_2008" Or @OSVersion = "WIN_VISTA" Or @OSVersion = "WIN_2003" Or @OSVersion="WIN_XP" Then
$fo = FileOpenDialog("Import",@ScriptDir,"Documents (*.rtf;*.docx;*.odt;*.doc;*.htm;*.html)",1)
Else
$fo = FileOpenDialog("Import",@ScriptDir,"Documents (*.rtf;*.doc;*.htm;*.html)",1)
EndIf
If @error <> 1 Then
If AreYouSure() = 6 Then
$sv = ""
If StringLower(StringRight($fo,4)) = "docx" Then
GUICtrlSetData($edit,ProcessDOCXFile($fo))
EndIf
If  StringLower(StringRight($fo,3)) = "odt" Then
GUICtrlSetData($edit,ProcessODTFile($fo))
EndIf
If StringLower(StringRight($fo,3)) = "rtf" Then
$data = FileRead($fo)
GUICtrlSetData($edit,ProcessRTF($data))
EndIf
If StringLower(StringRight($fo,3)) = "doc" Then
$data = FileRead($fo)
If StringLeft($data,6) = "{\rtf1" Then
GUICtrlSetData($edit,ProcessRTF($data))
Else
GUICtrlSetData($edit,ProcessDOC($data))
EndIf
EndIf
If StringLower(StringRight($fo,3)) = "htm" Or StringLower(StringRight($fo,4)) = "html" Then
$data = FileRead($fo)
GUICtrlSetData($edit,ProcessHTML($data))
EndIf
EndIf
EndIf
$r = GUICtrlRead($edit)
$i = 0
While $i = 0
If StringRight($r,2) = @CRLF Then
$r = StringTrimRight($r,2)
Else
$i = 1
EndIf
Wend
GUICtrlSetData($edit,$r)
EndFunc

#Global Functions

Func AreYouSure()
$ays = 6
If FileRead($sv) <> GUICtrlRead($edit) Then
$ays = MsgBox(4+48+8192,"Are you sure?","Doing this will delete any unsaved work!")
EndIf
Return $ays
EndFunc

Func ProcessHTML($dat)
While StringInStr($dat,"<!--[if gte mso 9]>") > 0
$front = StringLeft($dat,StringInStr($dat,"<!--[if gte mso 9]>"))
$end = StringTrimLeft($dat,StringInStr($dat,"<![endif]-->",0,1,StringLen($front)))
$dat = $front & $end
Wend
$dat = StringRegExpReplace($dat,"([^<]*)*<![endif]-->","")
$dat = StringReplace($dat,@CR,"")
$dat = StringReplace($dat,@LF,"")
$dat = StringReplace($dat,@TAB,"")
$dat = StringReplace($dat,"<br>",@CRLF)
$dat = StringReplace($dat,"<BR>",@CRLF)
$dat = StringReplace($dat,"</br>",@CRLF)
$dat = StringReplace($dat,"</BR>",@CRLF)
$dat = StringReplace($dat,"</p>",@CRLF)
$dat = StringReplace($dat,"</P>",@CRLF)
$dat = StringReplace($dat,"</li>",@CRLF)
$dat = StringReplace($dat,"</LI>",@CRLF)
$dat = StringReplace($dat,"</title>",@CRLF)
$dat = StringReplace($dat,"</TITLE>",@CRLF)
$dat = StringReplace($dat,"<![CDATA[","")
$dat = StringRegExpReplace($dat,"</h.>",@CRLF)
$dat = StringRegExpReplace($dat,"</H.>",@CRLF)
$dat = StringRegExpReplace($dat,"<!--([^-]*)-->","")
$dat = StringRegExpReplace($dat,"<script[^>]*>([^<]*)</script>","")
$dat = StringRegExpReplace($dat,"<SCRIPT[^>]*>([^<]*)</SCRIPT>","")
$dat = StringRegExpReplace($dat,"<style[^>]*>([^<]*)</style>","")
$dat = StringRegExpReplace($dat,"<STYLE[^>]*>([^<]*)</STYLE>","")
$dat = StringRegExpReplace($dat,"<[^>]+>","")
$dat = StringReplace($dat,"&nbsp;"," ")
$dat = StringReplace($dat,"&amp;","&")
$dat = StringReplace($dat,"&lt;","<")
$dat = StringReplace($dat,"&gt;",">")
Return $dat
EndFunc

Func ProcessODTFile($fn)
FileCopy($fn,@TempDir&"\test.zip")
_Zip_Unzip(@TempDir&"\test.zip","content.xml",@TempDir)
$fr = FileRead(@TempDir&"\content.xml")
DirRemove(@TempDir&"\xml",1)
FileDelete(@TempDir&"\test.zip")
FileDelete(@TempDir&"\content.xml")
$fr = StringReplace($fr,@CR,"")
$fr = StringReplace($fr,@LF,"")
$fr = StringReplace($fr,"","")
$fr = StringReplace($fr,"</text:p></table:table-cell>","")
$fr = StringReplace($fr,"</table:table-row>",@CRLF)
$fr = StringReplace($fr,"</text:p>",@CRLF)
$fr = StringRegExpReplace($fr,"<[^>]+>","")
$fr = StringLeft($fr,StringLen($fr)-2)
$fr = StringReplace($fr,"&nbsp;"," ")
$fr = StringReplace($fr,"&amp;","&")
$fr = StringReplace($fr,"&lt;","<")
$fr = StringReplace($fr,"&gt;",">")
DirRemove(@TempDir&"\Temporary Directory 1 for test.zip",1)
Return $fr
EndFunc

Func ProcessDOCXFile($fn)
FileCopy($fn,@TempDir&"\test.zip")
DirCreate(@TempDir&"\xml")
_Zip_UnzipAll(@TempDir&"\test.zip",@TempDir&"\xml")
FileCopy(@TempDir&"\xml\word\document.xml",@TempDir&"\test.xml")
$fr = FileRead(@TempDir&"\test.xml")
DirRemove(@TempDir&"\xml",1)
FileDelete(@TempDir&"\test.zip")
FileDelete(@TempDir&"\test.xml")
$fr = StringReplace($fr,@CR,"")
$fr = StringReplace($fr,@LF,"")
$fr = StringReplace($fr,"</w:pPr","<")
$fr = StringReplace($fr,"</w:p",@CRLF&"<")
$fr = StringRegExpReplace($fr,"(\r\n)*",@CRLF)
$fr = StringRegExpReplace($fr,"<([^>]+)>","")
$fr = StringReplace($fr,"<","")
$fr = StringReplace($fr,">","")
$fr = StringReplace($fr,"xml:space=""preserve""","")
$fr = StringReplace($fr,"&nbsp;"," ")
$fr = StringReplace($fr,"&amp;","&")
$fr = StringReplace($fr,"&lt;","<")
$fr = StringReplace($fr,"&gt;",">")
DirRemove(@TempDir&"\Temporary Directory 1 for test.zip",1)
Return $fr
EndFunc

Func ProcessDOC($s)
$s = StringSplit($s,"")
$str = ""
Dim $ac[71]
$ac[1] ="A"
$ac[2] = "B"
$ac[3] = "C"
$ac[4] = "D"
$ac[5] = "E"
$ac[6] = "F"
$ac[7] = "G"
$ac[8] = "H"
$ac[9] = "I"
$ac[10] = "J"
$ac[11] = "K"
$ac[12] = "L"
$ac[13] = "M"
$ac[14] = "N"
$ac[15] = "O"
$ac[16] = "P"
$ac[17] = "Q"
$ac[18] = "R"
$ac[19] = "S"
$ac[20] = "T"
$ac[21] = "U"
$ac[22] = "V"
$ac[23] = "W"
$ac[24] = "X"
$ac[25] = "Y"
$ac[26] = "Z"
$ac[27] = " "
$ac[28] = "."
$ac[29] = "!"
$ac[30] = "?"
$ac[31] = ","
$ac[32] = ":"
$ac[33] = ";"
$ac[34] = """"
$ac[35] = @CR
$ac[36] = "@"
$ac[37] = "#"
$ac[38] = "$"
$ac[39] = "%"
$ac[40] = "^"
$ac[41] = "&"
$ac[42] = "*"
$ac[43] = "("
$ac[44] = ")"
$ac[45] = "-"
$ac[46] = "_"
$ac[47] = "+"
$ac[48] = "="
$ac[49] = "{"
$ac[50] = "}"
$ac[51] = "["
$ac[52] = "]"
$ac[53] = "|"
$ac[54] = "\"
$ac[55] = "'"
$ac[56] = "<"
$ac[57] = ">"
$ac[58] = "/"
$ac[59] = "~"
$ac[60] = "`"
$ac[61] = "1"
$ac[62] = "2"
$ac[63] = "3"
$ac[64] = "4"
$ac[65] = "5"
$ac[66] = "6"
$ac[67] = "7"
$ac[68] = "8"
$ac[69] = "9"
$ac[70] = "0"
For $i = 1 To $s[0]
For $j = 1 To 70
If $s[$i] = $ac[$j] Then $str = $str & $s[$i]
Next
Next
$str = StringReplace($str,@CR,@CRLF)
$str = StringReplace($str,";"&@CRLF&"Root Entry"&@CRLF,"")
$str = StringReplace($str,">"&@CRLF&"5@Ul *","")
$str = StringReplace($str,"!""#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHJF","")
$str = StringReplace($str," !""#$%&'(*+,-./0123456789:;<=>?@ACDEFGH","")
$str = StringReplace($str,"Microsoft Word-DokumentMSWordDocWord.Document.8","")
$str = StringReplace($str,"Microsoft"&@CRLF&"Word-DokumentMSWordDocWord.Document.8","")
$str = StringReplace($str,"Microsoft "&@CRLF&"Word-DokumentMSWordDocWord.Document.8","")
$str = StringReplace($str,"9q[hhDefault1$*$7$5$3$A$3B*OJQJCJmHsHKHPJnH^JaJ_HtHBA@BAbsatz-StandardschriftartFFHeading"&@CRLF,"")
$str = StringReplace($str,"x$OJQJCJPJ^JaJ.B.Text bodyx / List^J@""@Caption"&@CRLF,"")
$str = StringReplace($str,"xx$CJ6^JaJ]&2&Index$^JPG","")
$str = StringReplace($str,"Times New Roman5Symbol3&ArialCLucida GrandeOLucida Sans Unicode5Tahoma5Tahoma","")
$str = StringReplace($str,"BhJDZF--'0Oh+'0|8@LXd"&@CRLF,"")
$str = StringReplace($str,"p3@@@zB@.lDM 0Caolan80$l4(4a@XL@","")
$str = StringReplace($str,"kFlF!0.Oh+'0|$"&@CRLF,"")
$str = StringReplace($str,"Normal1$PJmHnH_Hph^`^Heading 1 $$x-D@&M5CJ$OJQJ^JaJ$\B`BHeading 2-D@&MCJ aJ B`!BHeading 3-D@&MCJaJ<A@<Default Paragraph FontVUnknownVGTimes New Roman5Symbol3&Arial5SimSun","")
$str = StringReplace($str,"""d/ =!m""m#m$m%[:`:","")
$str = StringReplace($str,@CRLF&"$>@5\OJQJOJQJCJ85aJ8\OJQJ$>@$a$$a$""/ =!n""n#n$n3P(20.+,D.+,\","")
$str = StringReplace($str,"0<DLTlt@@@`lT@zTTextMaker 2006F9q"&@CRLF,"")
$str = StringReplace($str,"Root EntryFCompObjjOle1TableoSummaryInformation(WordDocument $DocumentSummaryInformation8It","")
$str = StringReplace($str,"Root EntryqTqT1TableqTqT)CompObjqTqTIjObjectPoolqTqTWordDocumentqTqTSummaryInformation(qTqTB","")
$str = StringReplace($str,"""J","")
$str = StringReplace($str,">*,)#`Abjbjmm.A\\\\h{$1hb  5""t }\K0{  {\\","")
$str = StringReplace($str,"T`hpx","")
$str = StringReplace($str,"1Microsoft Office Word@F#@j}@}8.+,0hp|","")
$str = StringReplace($str,"@'","")
$str = StringReplace($str,"Title"&@CRLF&" ""#$%&'(+Root EntryF}-Data1TableWordDocument.SummaryInformation(DocumentSummaryInformation8!CompObjqFMicrosoft Office Word DocumentMSWordDocWord.Document.89q","")
Return $str
EndFunc

Func ProcessRTF($data)
$data = StringReplace($data,@CR,"",0,2)
$data = StringReplace($data,@LF,"",0,2)
$data = StringReplace($data,"\line",@CRLF,0,2)
$data = StringReplace($data,"\pard","",0,2)
$data = StringReplace($data,"\par",@CRLF,0,2)
$data = StringReplace($data,"\trowd",@CRLF,0,2)
$data = StringRegExpReplace($data,"\A.+;","")
$data = StringRegExpReplace($data,";.+;","")
$data = StringRegExpReplace($data,"{\\pict[^\}]+","")
$data = StringRegExpReplace($data,"{\\header(.+{.+}.+)","")
$data = StringRegExpReplace($data,"\\\S* ","")
$data = StringRegExpReplace($data,"\\\S*\r\n","")
$data = StringRegExpReplace($data,"\\\S*\s","")
$data = StringReplace($data,"{","",0,2)
$data = StringRegExpReplace($data,"HYPERLINK [^ ]+ ","")
$data = StringReplace($data," }","",0,2)
$data = StringReplace($data,"}","",0,2)
$data = StringReplace($data,"StarWriter","",0,2)
$data = StringReplace($data,"Standard;","",0,2)
Return $data
EndFunc

Func GetSel()
GUISwitch($win)
$sel = _GUICtrlEdit_GetSel($edit)
$st = StringLeft(GUICtrlRead($edit),$sel[1])
$st = StringTrimLeft($st,$sel[0])
Return $st
EndFunc

Func Add($gridv)
$iscrlf = StringLeft(GUICtrlRead($edit),$sel[0]-1)
$iscrlf = StringRight($iscrlf,1)
If $iscrlf <> @CR And $iscrlf <> "" Then $gridv = @CRLF & $gridv
$iscrlfe = StringTrimLeft(GUICtrlRead($edit),$sel[1])
$iscrlfe = StringLeft($iscrlfe,1)
If $iscrlfe <> @CR And $iscrlfe <> "" Then $gridv = $gridv & @CRLF
$front = StringLeft(GUICtrlRead($edit),$sel[0])
$back = StringTrimLeft(GUICtrlRead($edit),$sel[1])
GUICtrlSetData($edit,$front&$gridv&$back)
_GUICtrlEdit_Scroll($edit,$SB_SCROLLCARET)
EndFunc

Func EnterFix($s)
$s = StringReplace($s,@CRLF,@LF)
$s = StringReplace($s,@LF,@CRLF)
$s = StringReplace($s,@CRLF,@CR)
$s = StringReplace($s,@CR,@CRLF)
Return $s
EndFunc

Func AddNoLine($dt)
$front = StringLeft(GUICtrlRead($edit),$sel[0])
$back = StringTrimLeft(GUICtrlRead($edit),$sel[1])
GUICtrlSetData($edit,$front& $dt &$back)
EndFunc